/*
 *	Copyright (c) 1994, 1995 by Jeremy Cooperstock and Steve Kotsopoulos,
 *	All Rights Reserved.
 */

/*
 * afdpjoin.h - header file for secretary and subscriber
 *
 * rcsid[] = "$Id: afdpjoin.h,v 1.15 1998/07/02 19:37:36 steve Exp $";
 *
 */

/* misc globals */
extern group_id_t mygroup;		/* to whom do I belong?             */
extern host_t  secretary_host;		/* host_id of secretary 	    */	
extern host_t  publisher_host;		/* host_id of publisher 	    */	
extern u_int threshold;			/* when to switch mode		    */
extern u_char multicast_ttl;		/* for multicasting over Internet   */
extern char *safe_command;
extern boolean_t opt_random_wait;

/* sockets globals */
extern int 	search_sock;		/* UDP socket for find_secretary    */
extern int	admin_sock; 		/* TCP socket for join/leave        */
extern int	publish_sock; 		/* TCP socket for publish permit    */
extern int      group_data_sock;	/* UDP socket for msg send/resend   */
extern port_t 	search_port;		/* port for find secretary          */
extern port_t 	admin_port; 		/* port for secretary<->subscribers */
extern port_t 	publish_port; 		/* port for client<->secretary      */
extern port_t   group_data_port;	/* port for client->subscribers     */

/* function prototypes in afdpjoin.c */
void Usage(), Version();
void GetPacket();
int Check();
void BecomeSecretary(), BecomeSubscriber(), Receive(), Shutdown ();

/* function prototypes in subscriber.c */
int Join();
int Leave();
void HandleGroupDataPacket();

/* function prototypes in secretary.c */
void HandleSearchPacket();
void HandleAdminPacket();
void HandlePublishPacket();
u_char CalcMode();
time_t CalcInterval();
u_short CalcUniList();

int IsMember(), AddMember(), DelMember(), IsClient(), AddClient(), DelClient();
void UpdateInterval();
time_t CalcInterval();

/* function prototypes for timer.c */
void StartTimer(), CancelTimer(), ClockTick();

